#!/bin/sh

############################################################################
#### Dieses Script brennt MP3s oder WAVs welche in einer BURNLIST	####
#### (burnlist.m3u) eingetragen sind auf CD, und zwar als AUDIO-CD mit  ####
#### CD-TEXT (ist nur fuer Spezialfaelle gedacht - wo man z.b: MP3s	####
#### oder WAVs aus dem Internet hat und mit diesen eine Mixed AUDIO-CD	####
#### erstellen moechte, da es hierbei natuerlich keinen CD-TEXT gibt).	####
#### Wobei das nur funktioniert wenn entweder MP3s oder WAVs in der	####
#### BURNLIST stehen - nicht wenn gemischt also MP3s und WAVs.		####
#### Weiters funktioniert das Script nur wenn ein Rohling zum Brennen	####
#### eingelegt ist. Es braucht dazu folgende Programme;			####
#### cdrecord,cdrdao,sox,lame, und ein paar andere die eh jeder hat.	####
############################################################################

## Variablen ##
CDRECORD="/usr/bin/cdrecord"
#CDRECORDDEV="0,0,0"
CDRECORDDEV="4,0,0"
DRIVEROPTS="burnfree"
#SPEED="4"
CDRDAO="/usr/bin/cdrdao"
#CDRDAODEV="/dev/cdrw"
CDRDAODEV="/dev/dvdrw"
CDRDAODRV="generic-mmc-raw"
LAME="/usr/bin/lame"
SOX="/usr/bin/sox"
NORMALIZE="/usr/bin/normalize-audio"
NICE="/usr/bin/nice"
NICEOPTS="-n 19"
SVDRPSEND="/usr/bin/svdrpsend"

TEMPDIR="/media/sdb1/media/workdir/audio/burn_mp3_or_wavplaylist2audiocd/tmp"
CDTEXT="audio.txt"
LOGDIR="/media/sdb1/media/workdir/audio/burn_mp3_or_wavplaylist2audiocd/log"
LOGFILE="$LOGDIR/burn_mp3_or_wavplaylist2audiocd.log"

BURNLIST="/usr/share/vdr-plugin-music/music/playlists/burnlist.m3u"

MP3=mp3
WAV=wav

ISO=mp3burn.iso


### Der Job beginnt !
$SVDRPSEND MESG "! Starte Job - BURNLIST zu AUDIO-CD !"
sleep 6


OLD_IFS=$IFS
IFS='
'


### Loeschen eventuell vorhandener alter Files (mp3,wav)
### falls es im Script schon einmal zum Abbruch kam.
$NICE $NICEOPTS rm -f $TEMPDIR/*

### Logfile der letzten Umwandlung loeschen.
if [ -e $LOGFILE ] ; then
    rm -f $LOGFILE
fi


### Falls nicht vorhanden, TEMPDIR erstellen.
#if [ ! -d $TEMPDIR ]; then
#	mkdir -p $TEMPDIR
#fi


### Ausgaben der folgenden Befehle (Programme) an LOGFILE anhaengen.
exec >>$LOGFILE; exec 2>&1


### Pruefen ob bereits eine CD eingelegt ist, falls nein Abbruch.
$CDRECORD dev=$CDRECORDDEV -minfo &> $LOGFILE
NOCD=$(awk '/cdrecord: No disk/ {print $2,$3}' $LOGFILE)
if [ "$NOCD" = "No disk" ]; then
    echo -e "\n\n! ABBRUCH !\nKeine CD-R(W) zum Brennen eingelegt\n\n"
    $SVDRPSEND MESG "ABBRUCH ! Keine CD-R(W) zum Brennen eingelegt !" && eject $CDRDAODEV && exit 1
fi


### Auslesen welcher Rohling (ob CD-R bzw. CD-RW) eingelegt
### ist. Falls es sich um eine CD-RW handelt welche voll ist
### wird diese geloescht. Falls es eine volle CD-R ist, Abbruch.
$CDRDAO disk-info --driver $CDRDAODRV --device $CDRDAODEV > $LOGFILE
EMPTY=$(awk '/CD-R empty/ {print $4}' $LOGFILE)
while [ "$EMPTY" != "yes" ]
do
    if [ "$EMPTY" = "no" ]; then
	CDRW=$(awk '/CD-RW/ {print $3}' $LOGFILE)
		
		if [ "$CDRW" = "yes" ]; then
			echo -e "\nEingelegte CD-RW = voll -> Starte Loeschen ...\n"
			$SVDRPSEND MESG "Eingelegte CD-RW = voll -> Starte Loeschen"
			$CDRECORD -v dev=$CDRECORDDEV blank=fast gracetime=3

				if [ "$?" = "0" ]; then
					echo -e "\nCD-RW Loeschen erfolgreich beendet\n\n"
					$SVDRPSEND MESG "CD-RW Loeschen erfolgreich beendet"
					$CDRDAO disk-info --driver $CDRDAODRV --device $CDRDAODEV >> $LOGFILE && sleep 3 && break
				else
					echo -e "\n! ABBRUCH !\nCD-RW Loeschen fehlgeschlagen\n"
					$SVDRPSEND MESG "ABBRUCH ! CD-RW Loeschen fehlgeschlagen !" && exit 1
				fi
		else
			echo -e "\n\n! ABBRUCH !\nEingelegte CD-R = voll\n\n"
			$SVDRPSEND MESG "ABBRUCH ! Eingelegte CD-R = voll !" && eject $CDRDAODEV && exit 1
		fi
    fi
done


### Brenntempo festlegen (wenn moeglich auslesen, ansonsten 8x Tempo).
NORMALY_SPEED="8"
NO_DISKSPEED=$(grep -m 1 "Recording Speed" <$LOGFILE | awk '{print $4}')
if [ "$NO_DISKSPEED" = "n/a" ]; then
	SPEED=$NORMALY_SPEED
else
	#DISKSPEED=$(grep -m 1 "Recording Speed" <$LOGFILE | awk '{print $6}')
	#DISKSPEED=${DISKSPEED%?}
	DISKSPEED=$(grep -m 1 "Recording Speed" <$LOGFILE | awk '{print $6}'  | sed 's/.$//')

	    ### Bei ausgelesenem Brenntempo auf hoechstens 24x Tempo begrenzen.
	    if [ $DISKSPEED -gt "24" ]; then
		SPEED="24"
	    else
		SPEED=$DISKSPEED
	    fi
fi
echo -e "\nBrenntempo wird auf "${SPEED}"x festgelegt\n"


### Speicherkapazitaet des Rohlings auslesen, und zur Sicherheit
### 30 MB davon abziehen (subtrahieren), damit spaeter die WAVs
### bzw. die zu WAV umgewandelten MP3s ohne Probleme auf den
### Rohling gebrannt werden koennen.
MEDIASIZE=$(cat $LOGFILE | grep -v "n/a" | grep "Total Capacity" | awk '{print $7}' | cut -f1 -d/)
echo -e "\nRohlingsgroesse = $MEDIASIZE MB"
MEDIASIZE=$(($MEDIASIZE - 30))
echo "Rohlingsgroesse nach 30 MB Sicherheitsabzug = $MEDIASIZE MB"


### Pruefen ob MP3s oder WAVs in der BURNLIST eingetragen sind.
FILE=$(grep -m 1 ".*" <$BURNLIST)
EXTENSION="${FILE##*.}"


### CDTEXT erstellen fuer spaeteres Brennen mittels cdrdao.
cdtext_creation() {
echo -e "\nErzeuge $CDTEXT im Verzeichnis\n$TEMPDIR\n ...\n"

		{
		echo -e "CD_DA\n\nCD_TEXT {\n  LANGUAGE_MAP {\n    0 : EN\n  }\n\n  LANGUAGE 0 {"
		echo -e "    TITLE \"Mixed CD\"\n    PERFORMER \"Various Artists\"\n  }\n}\n"
		for file in $TEMPDIR/*.wav ; do
		    file="$(basename "$file")"
		    titel="$(basename "$file" .wav)"
		    echo "TRACK AUDIO"
		    echo "CD_TEXT {"
		    echo "  LANGUAGE 0 {"
		    echo "    TITLE \"$titel\""
		    echo "    PERFORMER \"Any Artist\""
		    echo "  }"
		    echo "}"
		    echo "PREGAP 0:1:0"
		    echo -e "FILE \"$file\" 0\n"
		done
		} > $TEMPDIR/$CDTEXT

		if [ "$?" = "0" ]; then
		    echo -e "Erzeugen der $CDTEXT im Verzeichnis\n$TEMPDIR\nerfolgreich abgeschlossen\n"
		else
		    rm -f $TEMPDIR/$CDTEXT
		    echo -e "\n! INFO !\nErzeugen der $CDTEXT im Verzeichnis\n$TEMPDIR\nfehlgeschlagen"
		    echo -e "deshalb wird spaeter beim Brennen der WAVs\nicht cdrdao verwendet sondern cdrecord"
		    echo -e "wobei die fertige AUDIO-CD dann\naber keinen CD-TEXT beinhaltet\n\n"
		fi
}

### Wenn in der BURNLIST MP3s eingetragen sind, umwandeln zu WAVs und gleich
### im TEMPDIR ablegen, wenn hingegen von Haus aus WAVs in der BURNLIST, diese
### einfach in den TEMPDIR kopieren.
### Wobei wenn die Speicherkapazitaet des Rohlings ueberschritten wird, so wird
### wenn MP3s welche ja erst zu WAVs gewandelt werden muessen die letzte WAV
### (die mit der genau die Speicherkapazitaet des Rohlings ueberschritten wurde)
### wieder aus dem TEMPDIR geloescht. Wenn hingegen von Haus aus WAVs in der
### BURNLIST eingetragen sind (die ja nicht erst gewandelt werden muessen) so wird
### einfach ab einschliesslich der WAV mit der die Speicherkapazitaet des Rohlings
### ueberschritten wird keine weitere WAV in den TEMPDIR kopiert.
case $EXTENSION in
        $MP3)

		echo -e "\n\nKonvertiere MP3s zu WAVs nach;\n$TEMPDIR/*.wav\n ...\n"

		while read track ; do
		    outfile="$(basename "$track" .mp3).wav"
		    #outfile="${outfile// /_}"
		    outfile="$(echo $outfile | sed 's/^\([[:digit:]]\+\)\ \(.*\)$/\1.\2/;s/\ /_/g')"
		    #outfile="$(echo $outfile | sed 's/\([[:digit:]]\+\)\(\ \)\(.*\)/\1.\3/;s/\.mp3$/.wav/;s/\ /_/g')"
		    #$NICE $NICEOPTS $LAME --decode --silent $track "$TEMPDIR/$outfile"
		    $NICE $NICEOPTS $SOX $track -V2 -c 2 -r 44100 "$TEMPDIR/$outfile"
		    $NICE $NICEOPTS $NORMALIZE -m "$TEMPDIR/$outfile"

		    FILESIZE=$(ls -l "$TEMPDIR/$outfile" | awk '{print $5}')
		    FILESIZE=$(($FILESIZE /1024 /1024))
		    CURRENTSIZE=$(($CURRENTSIZE + $FILESIZE))

			if [ $CURRENTSIZE -gt $MEDIASIZE ]; then
			    echo -e "\nLoesche letzte WAV mit Namen;\n$outfile\naus dem Verzeichnis;\n$TEMPDIR"
			    echo -e "da ansonsten spaeter beim Brennen die Speicherkapazitaet\ndes Rohlings ueberschritten werden wuerde"
			    rm -f "$TEMPDIR/$outfile"
			    break
			fi
		done < $BURNLIST

		if [ "$?" = "0" ]; then
		    echo -e "\nKonvertieren der MP3s zu WAVs nach;\n$TEMPDIR/*.wav\nerfolgreich abgeschlossen\n"
		else
		    echo -e "\n! ABBRUCH !\nKonvertieren der MP3s zu WAVs nach;\n$TEMPDIR/*.wav\nfehlgeschlagen\n\n"
		    $SVDRPSEND MESG "ABBRUCH ! Konvertieren der MP3s zu WAVs fehlgeschlagen !" && exit 1
		fi

		cdtext_creation

        ;;

        $WAV)

		BURNLIST_LINE=0
		echo -e "\n\nKopiere WAVs nach;\n$TEMPDIR\n ...\n"

		while read track ; do
		    FILESIZE=$(ls -l $track | awk '{print $5}')
		    FILESIZE=$(($FILESIZE /1024 /1024))
		    CURRENTSIZE=$(($CURRENTSIZE + $FILESIZE))
		    BURNLIST_LINE=$((BURNLIST_LINE+1))

			if [ $CURRENTSIZE -lt $MEDIASIZE ]; then
			    outfile="$(basename "$track")"
			    outfile="$(echo $outfile | sed 's/^\([[:digit:]]\+\)\ \(.*\)$/\1.\2/;s/\ /_/g')"
			    $NICE $NICEOPTS cp -f "$track" "$TEMPDIR/$outfile"
			else
			    echo -e "\nWAVs ab einschliesslich Zeile;\n$BURNLIST_LINE\nwerden nicht weiter in den;\n$TEMPDIR"
			    echo -e "kopiert da ansonsten spaeter beim Brennen die Speicherkapazitaet\ndes Rohlings ueberschritten werden wuerde"
			    break
			fi
		done < $BURNLIST

		if [ "$?" = "0" ]; then
		    echo -e "\nKopieren der WAVs nach;\n$TEMPDIR\nerfolgreich abgeschlossen\n"
		else
		    echo -e "\n! ABBRUCH !\nKopieren der WAVs nach;\n$TEMPDIR\nfehlgeschlagen\n\n"
		    $SVDRPSEND MESG "ABBRUCH ! Kopieren der WAVs fehlgeschlagen !" && exit 1
		fi

		cdtext_creation

        ;;

        *)

		echo -e "\n\n! ABBRUCH !\nKeine MP3s oder WAVs in der;\n$BURNLIST\nzum Bearbeiten gefunden\n\n"
		$SVDRPSEND MESG "ABBRUCH ! Keine MP3s oder WAVs in der BURNLIST !" && exit 1

        ;;
esac


### Wenn zuvor die CDTEXT erfolgreich erzeugt wurde, Brennen der WAVs mittels cdrdao
### mit und ueber CDTEXT, andernfalls werden die WAVs direkt mittels cdrecord gebrannt.
### Wobei bei der Verwendung von cdrdao mit CDTEXT gibt es zum Einen CDTEXT auf der
### fertigen AUDIO-CD, und man kann sofern in der CDTEXT angegeben z.b: PREGAP 0:1:0
### (steht fuer eine Sekunde) zwischen den einzelnen Titel eine gap Zeit
### (eine Zeitspanne in Sekunden) angeben bevor der naechste Titel starten soll.
### Aus diesem Grund ist ganz klar cdrdao mit CDTEXT die bevorzugte Variante.
if [ -e "$TEMPDIR/$CDTEXT" ]; then
    echo -e "\nStarte Brennen der WAVs mittels cdrdao ...\n"
    cd $TEMPDIR
    $NICE $NICEOPTS $CDRDAO write --device $CDRDAODEV --driver $CDRDAODRV --speed $SPEED $CDTEXT
else
    echo -e "\nStarte Brennen der WAVs mittels cdrecord ...\n"
    $NICE $NICEOPTS $CDRECORD -v -pad -audio dev=$CDRECORDDEV speed=$SPEED driveropts=$DRIVEROPTS $TEMPDIR/*.wav
fi

### Abfrage ob die WAVs gebrannt werden konnten, falls nein Abbruch.
if [ "$?" = "0" ]; then
    $NICE $NICEOPTS rm -f $TEMPDIR/* && \
    echo -e "\nBrennen der WAVs erfolgreich beendet\n\n\n! BURNLIST zu AUDIO-CD fertig !\n\n"
    $SVDRPSEND MESG "! BURNLIST zu AUDIO-CD FERTIG !" && eject $CDRDAODEV && eject -t $CDRDAODEV
else
    echo -e "\n! ABBRUCH !\nBrennen der WAVs fehlgeschlagen\n"
    $SVDRPSEND MESG "ABBRUCH ! Brennen der WAVs fehlgeschlagen !" && exit 1
fi


IFS=$OLD_IFS


exit
